<Query Kind="Program" />

// 93 is the chance of continuation for capture at 4 steps away.
private static int threshold = 93;

void Main()
{
    // Initial state
    string ram = "0123456789ABCDEF0123456789ABCDEF";
    string str0 = ram.Substring(16).Trim();
    string str1 = ram.Substring(0, 16);
    ulong s0 = Convert.ToUInt64(str0, 16);
    ulong s1 = Convert.ToUInt64(str1, 16);

    // Set this for how far you want to search.
    int maxAdvance = 200;

    var rng = new XorShift128(s0, s1);
    for (int advances = 0; advances < maxAdvance; advances++)
    {
        GetRadarContinue(advances, rng);
        rng.Next();
    }
}

// You can define other methods, fields, classes and namespaces here
private void GetRadarContinue(int advance, XorShift128 rng)
{
    var (s0, s1) = rng.GetState64();
    var output = $"{advance:000} | {s0:x16} | {s1:x16} |";
    
    var next = rng.NextInt(0, 100);
    output = output + $" {next:00} |";

    if (next >= threshold)
        output = output + " *";

    if (advance < 22)
        return;
    Console.WriteLine(output);
}